--  @(#) compile-schema.sql = invoke 'dbms_utility.compile_schema'
--  NOTES:
--    to recompile procedures, see "${ORACLE_HOME}/rdbms/admin/utlrp.sql"
--  SEE ALSO:
--    ./sw/oracle/analyze-schema.sql , ./sw/oracle/compile-schema.sql 
--  @(#) compile-schema.sql ; 1.3.0 03/03/05 18:32:20

whenever sqlerror exit sql.sqlcode ;
set serveroutput on

declare
vschema varchar2(40) ;
cnt     number := 0;

cursor oList(vOwn all_objects.owner%TYPE) is
    select object_name, object_type
      from all_objects 
     where status = 'INVALID'
       and object_type != 'VIEW'
       and owner = vschema;
begin
    select user into vschema from dual ; 

    dbms_utility.compile_schema ( vschema, TRUE ) ;

    select count(*) 
      into cnt
      from all_objects 
     where status = 'INVALID'
       and object_type != 'VIEW'
       and owner = vschema;

    if cnt > 0 then
       dbms_output.put_line('After compile schema still '||cnt||
       ' INVALID objects in schema '||vschema);
       dbms_output.put_line('running complete compile_schema');
       dbms_utility.compile_schema ( vschema, TRUE ) ;
    end if;

    select count(*) 
      into cnt
      from all_objects 
     where status = 'INVALID'
       and object_type != 'VIEW'
       and owner = vschema;
    if cnt > 0 then
       dbms_output.put_line('After second compile schema still '||cnt||
       ' INVALID objects in schema '||vschema);
       for r in oList(vschema) loop
         dbms_output.put_line( r.object_type ||' '|| r.object_name);
       end loop;
    end if;
    FOR cur_rec IN (SELECT owner,
                         object_name,
                         object_type
                  FROM   dba_objects
                  WHERE  object_type = 'VIEW'
                  AND    status != 'VALID'
                                  AND    owner = '${DBUSER_UC}' )

    LOOP
      BEGIN
        EXECUTE IMMEDIATE 'ALTER VIEW "' || cur_rec.owner ||
            '"."' || cur_rec.object_name || '" COMPILE';

    EXCEPTION
      WHEN OTHERS THEN
        DBMS_OUTPUT.put_line(cur_rec.object_type || ' : ' || cur_rec.owner ||
                             ' : ' || cur_rec.object_name);
    END;
  END LOOP;
END;
/

exit ;  
